#include "chdecl.h"
void CH_typestate_pocopyts(current, sched, cop)
#define ARGUMENTS 9
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto c3;
    case 4: goto c11;
    case 5: goto cb19;
    case 6: goto c20;
    case 7: goto cb27;
    case 8: goto c28;
    case 9: goto c31;
    case 10: goto cb39;
    case 11: goto c40;
    case 12: goto cb41;
    case 13: goto c42;
    case 14: goto c43;
    case 15: goto c54;
    case 16: goto c56;
    case 17: goto c58;
    case 18: goto c60;
    case 19: goto c73;
    case 20: goto c77;
    case 21: goto c83;
    case 22: goto c93;
    case 23: goto c103;
    case 24: goto c109;
    case 25: goto c120;
    case 26: goto c121;
    case 27: goto c123;
    case 28: goto c127;
    case 29: goto cb129;
    case 30: goto c130;
    case 31: goto c152;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* initget 4 3.5.2 , 0,0 */
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(4),DEF(3)DOT(5)DOT(2),nil,sched,GET,
    0,0)) != Normal) goto ch_raise_exception;
c3:
/* get_or_err 4 3.5.2 */
  if ((ch_returncode = get_selected_object(DEF(4),DEF(3)DOT(5)DOT(2)
    ,sched)) != Normal) goto ch_raise_exception;
/* position 5 4 */
  ch_frame = get_selector_frame(DEF(4),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(5).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(5).tsdr = &dr_integer;
/* lookup_at 6 3.7 =(0) */
  if ( !((ch_t = REF(3)DOT(7).value.table)->size) ) goto ch_notfound;
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(6).value,0);
  REF(6).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 7 6 */
  REF(7) = REF(6);
/* notequal . 5 7 , 3 */
  if ( REF(5).value.integer != REF(7).value.integer ) goto c3;
/* initget 8 3.5.2 , 0,0 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(8),DEF(3)DOT(5)DOT(2),nil,sched,GET,
    0,0)) != Normal) goto ch_raise_exception;
c11:
/* get_or_err 8 3.5.2 */
  if ((ch_returncode = get_selected_object(DEF(8),DEF(3)DOT(5)DOT(2)
    ,sched)) != Normal) goto ch_raise_exception;
/* position 9 8 */
  ch_frame = get_selector_frame(DEF(8),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(9).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(9).tsdr = &dr_integer;
/* lookup_at 10 3.7 =(1) */
  if (1 >= (ch_t = REF(3)DOT(7).value.table)->size) goto ch_notfound;
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(10).value,1);
  REF(10).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 11 10 */
  REF(11) = REF(10);
/* notequal . 9 11 , 11 */
  if ( REF(9).value.integer != REF(11).value.integer ) goto c11;
/* new_table 12 , 1 */
  if ((ch_returncode = che_new_table(DEF(12),QUAL(1),sched)) != Normal) 
     goto ch_raise_exception;
  current->ip = 5;
cb19:
/* call 3.0.4 3.6 4 12 13 , 2 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(0)DOT(4),
          arguments[1] = DEF(3)DOT(6),
          arguments[2] = DEF(4),
          arguments[3] = DEF(12),
          arguments[4] = DEF(13),
          arguments[4+1] = nil,& arguments[0]),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
  return;
c20:
/* size 14 4.1 */
  REF(14).value.integer = REF(4)DOT(1).value.table->size;
  REF(14).tsdr = & dr_integer;
/* ile . 14 =(0) , 73 */
  if ( REF(14).value.integer <= 0 ) goto c73;
/* new_record 15 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).value = ch_val; REF(15).tsdr = & dr_record;
/* copy 15.0 4.0 */
  if((ch_returncode = (REF(4)DOT(0).tsdr->copy)(& ch_val, REF(4)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(15)DOT(0).tsdr)->finalize)(REF(15)DOT(0).value,F_DISCARD,sched);
  REF(15)DOT(0).value = ch_val;
  REF(15)DOT(0).tsdr = datarepmap[REF(4)DOT(0).tsdr->number];
/* new_table 15.1 , 3 */
  if ((ch_returncode = che_new_table(DEF(15)DOT(1),QUAL(3),sched)) != Normal) 
     goto ch_raise_exception;
  current->ip = 7;
cb27:
/* call 3.0.13 3.0 3.1 3.3 3.2 15 16 , 4 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(0)DOT(13),
          arguments[1] = DEF(3)DOT(0),
          arguments[2] = DEF(3)DOT(1),
          arguments[3] = DEF(3)DOT(3),
          arguments[4] = DEF(3)DOT(2),
          arguments[5] = DEF(15),
          arguments[6] = DEF(16),
          arguments[6+1] = nil,& arguments[0]),QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
  return;
c28:
/* move 17 16 */
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  REF(17) = REF(16);
  REF(16).tsdr = & dr_bottom;
/* ilit 18 , 0 */
  REF(18).value.integer = 0;
  REF(18).tsdr = & dr_integer;
c31:
/* size 19 4.1 */
  REF(19).value.integer = REF(4)DOT(1).value.table->size;
  REF(19).tsdr = & dr_integer;
/* ige . 18 19 , 73 */
  if ( REF(18).value.integer >= REF(19).value.integer ) goto c73;
/* find 20 3.3 17.0 , 0 */
  if (findfunc(DEF(20),DEF(3)DOT(3),(
          arguments[0] = DEF(17)DOT(0),& arguments[0]),sched,0) == FAILURE)
             goto ch_notfound;
/* find 21 20.1 17.1 , 0 */
  if (findfunc(DEF(21),DEF(20)DOT(1),(
          arguments[0] = DEF(17)DOT(1),& arguments[0]),sched,0) == FAILURE)
             goto ch_notfound;
/* block , 5 */
  if((ch_returncode = che_block(QUAL(5),sched)) != Normal)
     goto ch_raise_exception;
/* reveal 21.2 , 10 */
  if (10 != REF(21)DOT(2).value.variant->info.variant_case)
     goto ch_case_error;
/* find 22 21.2.0.3 21.2.0.2 , 0 */
  if (findfunc(DEF(22),DEF(21)DOT(2)DOT(0)DOT(3),(
          arguments[0] = DEF(21)DOT(2)DOT(0)DOT(2),& arguments[0]),sched,0
            ) == FAILURE) goto ch_notfound;
  current->ip = 10;
cb39:
/* call 3.0.14 3.0 15 22.1 23 , 6 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(0)DOT(14),
          arguments[1] = DEF(3)DOT(0),
          arguments[2] = DEF(15),
          arguments[3] = DEF(22)DOT(1),
          arguments[4] = DEF(23),
          arguments[4+1] = nil,& arguments[0]),QUAL(6),sched)) != Normal)
     goto ch_raise_exception;
  return;
c40:
/* move 24 23 */
  (*(REF(24).tsdr)->finalize)(REF(24).value,F_DISCARD,sched);
  REF(24) = REF(23);
  REF(23).tsdr = & dr_bottom;
  current->ip = 12;
cb41:
/* call 3.0.4 24 4 12 25 , 2 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(0)DOT(4),
          arguments[1] = DEF(24),
          arguments[2] = DEF(4),
          arguments[3] = DEF(12),
          arguments[4] = DEF(25),
          arguments[4+1] = nil,& arguments[0]),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
  return;
c42:
/* block , 7 */
  if((ch_returncode = che_block(QUAL(7),sched)) != Normal)
     goto ch_raise_exception;
c43:
/* noop */
  
/* privatize 25 */
  if (REF(25).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(25))) != Normal)
       goto ch_raise_exception;
/* initget 26 25 , 0,0 */
  (*(REF(26).tsdr)->finalize)(REF(26).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(26),DEF(25),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
/* get_or_err 26 25 */
  if ((ch_returncode = get_selected_object(DEF(26),DEF(25),sched)) != Normal)
     goto ch_raise_exception;
/* remove 27 26 25 */
  if ((ch_returncode = che_remove(DEF(27),DEF(26),DEF(25),sched)) != Normal)
     goto ch_raise_exception;
/* endget 26 25 */
  end_selector(DEF(26),DEF(25),sched,GET);
/* block , 8 */
  if((ch_returncode = che_block(QUAL(8),sched)) != Normal)
     goto ch_raise_exception;
/* insert 13 27 */
  if ((ch_returncode = insertfunc(DEF(13),DEF(27),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* endblock */
  che_endblock(sched);
c54:
/* discard 27 */
  (*(REF(27).tsdr)->finalize)(REF(27).value,F_DISCARD,sched);
  REF(27).tsdr = & dr_bottom;
/* branch , 43 */
   goto c43;
c56:
/* endblock */
  che_endblock(sched);
c58:
/* endblock */
  che_endblock(sched);
c60:
/* discard 24 */
  (*(REF(24).tsdr)->finalize)(REF(24).value,F_DISCARD,sched);
  REF(24).tsdr = & dr_bottom;
/* discard 25 */
  (*(REF(25).tsdr)->finalize)(REF(25).value,F_DISCARD,sched);
  REF(25).tsdr = & dr_bottom;
/* lookup_at 28 4.1 18 */
  if((ch_i = REF(18).value.integer) < 0 || ch_i >= (ch_t = REF(4)DOT(1).value
    .table)->size) goto ch_notfound;
  (*(REF(28).tsdr)->finalize)(REF(28).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(28).value,ch_i);
  REF(28).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 29 28 */
  if((ch_returncode = (REF(28).tsdr->copy)(& ch_val, REF(28).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(29).tsdr)->finalize)(REF(29).value,F_DISCARD,sched);
  REF(29).value = ch_val;
  REF(29).tsdr = datarepmap[REF(28).tsdr->number];
/* find 30 21.1 29 , 0 */
  if (findfunc(DEF(30),DEF(21)DOT(1),(
          arguments[0] = DEF(29),& arguments[0]),sched,0) == FAILURE)
             goto ch_notfound;
/* copy 17 30.1 */
  if((ch_returncode = (REF(30)DOT(1).tsdr->copy)(& ch_val, REF(30)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  REF(17).value = ch_val;
  REF(17).tsdr = datarepmap[REF(30)DOT(1).tsdr->number];
/* insert 15.1 29 */
  if ((ch_returncode = insertfunc(DEF(15)DOT(1),DEF(29),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* iadd 18 18 =(1) */
  if (!chf_iadd(DEF(18),REF(18).value.integer,1)) goto ch_depletion;
/* branch , 31 */
   goto c31;
c73:
/* discard 15 */
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).tsdr = & dr_bottom;
/* discard 17 */
  (*(REF(17).tsdr)->finalize)(REF(17).value,F_DISCARD,sched);
  REF(17).tsdr = & dr_bottom;
/* copy 31 13 */
  if((ch_returncode = cp_table(& ch_val, REF(13).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31).value = ch_val;
  REF(31).tsdr = & dr_table;
/* initget 32 31 , 0,0 */
  (*(REF(32).tsdr)->finalize)(REF(32).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(32),DEF(31),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c77:
/* get_or_goto 32 31 , 127 */
  if ((ch_returncode = get_selected_object(DEF(32),DEF(31),sched)) != Normal)
     goto c127;
/* new_record 33 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(33).tsdr)->finalize)(REF(33).value,F_DISCARD,sched);
  REF(33).value = ch_val; REF(33).tsdr = & dr_record;
/* copy 33.0 32.0 */
  if((ch_returncode = (REF(32)DOT(0).tsdr->copy)(& ch_val, REF(32)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(33)DOT(0).tsdr)->finalize)(REF(33)DOT(0).value,F_DISCARD,sched);
  REF(33)DOT(0).value = ch_val;
  REF(33)DOT(0).tsdr = datarepmap[REF(32)DOT(0).tsdr->number];
/* new_table 33.1 , 3 */
  if ((ch_returncode = che_new_table(DEF(33)DOT(1),QUAL(3),sched)) != Normal) 
     goto ch_raise_exception;
/* copy 34 32.1 */
  if((ch_returncode = cp_table(& ch_val, REF(32)DOT(1).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(34).tsdr)->finalize)(REF(34).value,F_DISCARD,sched);
  REF(34).value = ch_val;
  REF(34).tsdr = & dr_table;
/* initget 35 34 , 0,0 */
  (*(REF(35).tsdr)->finalize)(REF(35).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(35),DEF(34),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c83:
/* get_or_goto 35 34 , 123 */
  if ((ch_returncode = get_selected_object(DEF(35),DEF(34),sched)) != Normal)
     goto c123;
/* equal 36 35.0 4.0 */
  REF(36).value.boolean = ((REF(35)DOT(0).tsdr->equal)(REF(35)DOT(0).value,
    REF(4)DOT(0).value));
  REF(36).tsdr = & dr_boolean;
/* size 37 35.1 */
  REF(37).value.integer = REF(35)DOT(1).value.table->size;
  REF(37).tsdr = & dr_integer;
/* size 38 4.1 */
  REF(38).value.integer = REF(4)DOT(1).value.table->size;
  REF(38).tsdr = & dr_integer;
/* ige 39 37 38 */
  REF(39).value.boolean = (REF(37).value.integer >= REF(38).value.integer);
/* and 40 36 39 */
  REF(40).value.boolean = REF(36).value.boolean&REF(39).value.boolean;
  REF(40).tsdr = & dr_boolean;
/* branch_false 40 , 103 */
  if ( !REF(40).value.boolean ) goto c103;
/* boolean 41 , TRUE */
  REF(41).value.boolean = TRUE;
  REF(41).tsdr = & dr_boolean;
/* initget 42 4.1 , 0,0 */
  (*(REF(42).tsdr)->finalize)(REF(42).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(42),DEF(4)DOT(1),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c93:
/* get_or_goto 42 4.1 , 101 */
  if ((ch_returncode = get_selected_object(DEF(42),DEF(4)DOT(1)
    ,sched)) != Normal) goto c101;
/* position 43 42 */
  ch_frame = get_selector_frame(DEF(42),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(43).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(43).tsdr = &dr_integer;
/* lookup_at 44 35.1 43 */
  if((ch_i = REF(43).value.integer) < 0 || ch_i >= (ch_t = REF(35)DOT(1).value
    .table)->size) goto ch_notfound;
  (*(REF(44).tsdr)->finalize)(REF(44).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(44).value,ch_i);
  REF(44).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 45 44 */
  if((ch_returncode = (REF(44).tsdr->copy)(& ch_val, REF(44).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(45).tsdr)->finalize)(REF(45).value,F_DISCARD,sched);
  REF(45).value = ch_val;
  REF(45).tsdr = datarepmap[REF(44).tsdr->number];
/* equal 46 45 42 */
  REF(46).value.boolean = ((REF(45).tsdr->equal)(REF(45).value,REF(42).value)
    );
  REF(46).tsdr = & dr_boolean;
/* discard 45 */
  (*(REF(45).tsdr)->finalize)(REF(45).value,F_DISCARD,sched);
  REF(45).tsdr = & dr_bottom;
/* branch_true 46 , 93 */
  if ( REF(46).value.boolean ) goto c93;
/* boolean 41 , FALSE */
  REF(41).value.boolean = FALSE;
  REF(41).tsdr = & dr_boolean;
c101:
/* endget 42 4.1 */
  end_selector(DEF(42),DEF(4)DOT(1),sched,GET);
/* move 40 41 */
  REF(40) = REF(41);
  REF(41).tsdr = & dr_bottom;
c103:
/* branch_false 40 , 120 */
  if ( !REF(40).value.boolean ) goto c120;
/* new_record 47 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(47).tsdr)->finalize)(REF(47).value,F_DISCARD,sched);
  REF(47).value = ch_val; REF(47).tsdr = & dr_record;
/* copy 47.0 8.0 */
  if((ch_returncode = (REF(8)DOT(0).tsdr->copy)(& ch_val, REF(8)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(47)DOT(0).tsdr)->finalize)(REF(47)DOT(0).value,F_DISCARD,sched);
  REF(47)DOT(0).value = ch_val;
  REF(47)DOT(0).tsdr = datarepmap[REF(8)DOT(0).tsdr->number];
/* copy 47.1 8.1 */
  if((ch_returncode = cp_table(& ch_val, REF(8)DOT(1).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(47)DOT(1).tsdr)->finalize)(REF(47)DOT(1).value,F_DISCARD,sched);
  REF(47)DOT(1).value = ch_val;
  REF(47)DOT(1).tsdr = & dr_table;
/* copy 48 35.1 */
  if((ch_returncode = cp_table(& ch_val, REF(35)DOT(1).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(48).tsdr)->finalize)(REF(48).value,F_DISCARD,sched);
  REF(48).value = ch_val;
  REF(48).tsdr = & dr_table;
/* initget 49 48 , 0,0 */
  (*(REF(49).tsdr)->finalize)(REF(49).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(49),DEF(48),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c109:
/* get_or_goto 49 48 , 117 */
  if ((ch_returncode = get_selected_object(DEF(49),DEF(48),sched)) != Normal)
     goto c117;
/* position 50 49 */
  ch_frame = get_selector_frame(DEF(49),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(50).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(50).tsdr = &dr_integer;
/* size 51 4.1 */
  REF(51).value.integer = REF(4)DOT(1).value.table->size;
  REF(51).tsdr = & dr_integer;
/* ilt . 50 51 , 109 */
  if ( REF(50).value.integer < REF(51).value.integer ) goto c109;
/* copy 52 49 */
  if((ch_returncode = (REF(49).tsdr->copy)(& ch_val, REF(49).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(52).tsdr)->finalize)(REF(52).value,F_DISCARD,sched);
  REF(52).value = ch_val;
  REF(52).tsdr = datarepmap[REF(49).tsdr->number];
/* insert 47.1 52 */
  if ((ch_returncode = insertfunc(DEF(47)DOT(1),DEF(52),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 109 */
   goto c109;
c117:
/* endget 49 48 */
  end_selector(DEF(49),DEF(48),sched,GET);
/* discard 48 */
  (*(REF(48).tsdr)->finalize)(REF(48).value,F_DISCARD,sched);
  REF(48).tsdr = & dr_bottom;
/* branch , 121 */
   goto c121;
c120:
/* copy 47 35 */
  if((ch_returncode = cp_record(& ch_val, REF(35).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(47).tsdr)->finalize)(REF(47).value,F_DISCARD,sched);
  REF(47).value = ch_val;
  REF(47).tsdr = & dr_record;
c121:
/* insert 33.1 47 */
  if ((ch_returncode = insertfunc(DEF(33)DOT(1),DEF(47),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 83 */
   goto c83;
c123:
/* endget 35 34 */
  end_selector(DEF(35),DEF(34),sched,GET);
/* discard 34 */
  (*(REF(34).tsdr)->finalize)(REF(34).value,F_DISCARD,sched);
  REF(34).tsdr = & dr_bottom;
/* insert 3.8.0 33 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(8)DOT(0),DEF(33)
    ,FALSE,0)) != Normal) goto ch_raise_exception;
/* branch , 77 */
   goto c77;
c127:
/* endget 32 31 */
  end_selector(DEF(32),DEF(31),sched,GET);
/* discard 31 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  REF(31).tsdr = & dr_bottom;
  current->ip = 29;
cb129:
/* call 3.0.4 3.6 8 12 53 , 2 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(0)DOT(4),
          arguments[1] = DEF(3)DOT(6),
          arguments[2] = DEF(8),
          arguments[3] = DEF(12),
          arguments[4] = DEF(53),
          arguments[4+1] = nil,& arguments[0]),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
  return;
c130:
/* size 54 53 */
  REF(54).value.integer = REF(53).value.table->size;
  REF(54).tsdr = & dr_integer;
/* ile . 54 =(0) , 147 */
  if ( REF(54).value.integer <= 0 ) goto c147;
/* privatize 53 */
  if (REF(53).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(53))) != Normal)
       goto ch_raise_exception;
/* initget 55 53 , 0,0 */
  (*(REF(55).tsdr)->finalize)(REF(55).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(55),DEF(53),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
/* get_or_err 55 53 */
  if ((ch_returncode = get_selected_object(DEF(55),DEF(53),sched)) != Normal)
     goto ch_raise_exception;
/* remove 56 55 53 */
  if ((ch_returncode = che_remove(DEF(56),DEF(55),DEF(53),sched)) != Normal)
     goto ch_raise_exception;
/* endget 55 53 */
  end_selector(DEF(55),DEF(53),sched,GET);
/* boolean 57 , FALSE */
  REF(57).value.boolean = FALSE;
  REF(57).tsdr = & dr_boolean;
/* find_or_goto 58 3.8.0 56 , 0,142 */
  if (findfunc(DEF(58),DEF(3)DOT(8)DOT(0),(
          arguments[0] = DEF(56),& arguments[0]),sched,0) == FAILURE) goto c142;
/* boolean 57 , TRUE */
  REF(57).value.boolean = TRUE;
  REF(57).tsdr = & dr_boolean;
c142:
/* branch_false 57 , 145 */
  if ( !REF(57).value.boolean ) goto c145;
/* discard 56 */
  (*(REF(56).tsdr)->finalize)(REF(56).value,F_DISCARD,sched);
  REF(56).tsdr = & dr_bottom;
/* branch , 130 */
   goto c130;
c145:
/* insert 3.8.1 56 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(8)DOT(1),DEF(56)
    ,FALSE,0)) != Normal) goto ch_raise_exception;
/* branch , 130 */
   goto c130;
c147:
/* endget 8 3.5.2 */
  end_selector(DEF(8),DEF(3)DOT(5)DOT(2),sched,GET);
/* endget 4 3.5.2 */
  end_selector(DEF(4),DEF(3)DOT(5)DOT(2),sched,GET);
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c152:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
